<template>
  <div>
    <div class="view">
      <div class="fractions" v-for="(fraction, i) in fractions" :key="i">
        <div class="fraction-body">
          <input
            min="1"
            max="99"
            type="number"
            v-model.number="fraction.numerator"
          />
          <hr />
          <input
            min="1"
            max="99"
            type="number"
            v-model.number="fraction.denominator"
          />
          <button v-if="showDelete" @click="deleteFraction(i)">X</button>
        </div>
        <h1 v-if="fractions[i + 1]">+</h1>
      </div>
      <h1>=</h1>
      <h1>{{ result }}</h1>
    </div>
    <button :disabled="fractionsCount === 5" @click="addFraction">
      Add new element
    </button>
  </div>
</template>

<script>
export default {
  name: 'App',
  data: () => ({
    fractions: [
      { numerator: 1, denominator: 1 },
      { numerator: 1, denominator: 1 },
    ],
  }),
  methods: {
    addFraction() {
      if (this.fractionsCount < 5) {
        this.fractions.push({ numerator: 1, denominator: 1 })
      }
    },
    deleteFraction(index) {
      this.fractions.splice(index, 1)
    },
  },
  computed: {
    result() {
      return this.fractions
        .map((i) => i.numerator / i.denominator)
        .reduce((i, prev) => i + prev)
    },
    fractionsCount() {
      return this.fractions.length
    },
    showDelete() {
      return this.fractionsCount > 2
    },
  },
  watch: {
    fractions: {
      deep: true,
      handler(newVal) {
        newVal.forEach((i) => {
          if (i.numerator >= 100) {
            i.numerator = 99
          }
          if (i.denominator >= 100) {
            i.denominator = 99
          }
        })

        newVal.forEach((i) => {
          if (i.numerator <= 0) {
            i.numerator = 1
          }
          if (i.denominator <= 0) {
            i.denominator = 1
          }
        })
      },
    },
  },
}
</script>

<style>
hr {
  margin: 7px 0;
}

button {
  margin-top: 7px;
}

.fraction-body {
  display: flex;
  flex-direction: column;
  margin: 0 5px;
}

.view {
  display: flex;
  flex-direction: row;
}

.fractions {
  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;
}
</style>
